## lighttpd2 2.0.0~snap-20170729-134019

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0 FATAL_ERROR)

PROJECT(lighttpd C)
SET(PACKAGE_NAME ${CMAKE_PROJECT_NAME})
SET(PACKAGE_VERSION 2.0.0)

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

#INCLUDE(CTest)
ENABLE_TESTING()

ADD_SUBDIRECTORY(src build)

add_subdirectory(tests)
