## lighttpd2 2.0.0~snap-20170729-134019-gbc6b25

=== debian/changelog ===
lighttpd2 (2.0.0~snap-20170729-134019-gbc6b25-1) unstable; urgency=low

  * new snapshot gbc6b25
    + [mod_openssl] fix crash with libressl or openssl < 1.1
    + [mod_openssl] fix C90 mixed declarations and code warning
    + [core] use readdir instead of readdir_r

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sat, 29 Jul 2017 13:59:11 +0000

lighttpd2 (2.0.0~snap-20170726-080037-g8c68b1-2) unstable; urgency=medium

  * split lists into one item per line in debian/control
  * remove deprecated (alternative) names in build dependencies
  * update debian/compat to 9
  * use debhelper without cdbs
    + /usr/lib contents now multiarch (libexecdir), update install and
      overrides accordingly
  * remove explicit -dbg package (-> dbgsym packages)

 -- Stefan Bühler <source@stbuehler.de>  Sat, 29 Jul 2017 15:52:33 +0200

lighttpd2 (2.0.0~snap-20170726-080037-g8c68b1-1) unstable; urgency=low

  * new snapshot g8c68b1
    + [cmake] handle include directories separately
    + [config] expect exactly one comma between list entries
    + use _DEFAULT_SOURCE instead of _BSD_SOURCE
    + [parsers] fix unused variable warnings
    + [mod_gnutls] use only pin callback, don't pass pin as parameter
    + [mod_gnutls] add basic OCSP response stapling support
    + [core] disable strict-alias warnings for libev wrappers
    + [mod_gnutls] use gnutls_pem_base64_decode_alloc instead of gnutls_pem_base64_decode2 (compat name for old versions)
    + [mod_gnutls/docs] ocsptool is the ocsp tool
    + [doc] decode HTML entities in code/markdown/textile blocks
    + [mod_gnutls/doc] more details which certificates are needed for OCSP
    + [mod_gnutls] workaround gnutls API breakage, and prepare for future ones
    + Add NO_TLSv1_1 and higher options
    + [mod_openssl/doc] Update links to man pages
    + [mod_openssl] fix warnings and compile breaks with openssl 1.1.0
    + [mimetypes.conf] add text/markdown to utf-8 list, regenerate mimetypes.conf
    + [plugin_core] support patterns in alias target
    + [doc build] remove markdown support
    + handle ENAMETOOLONG in various places
    + [plugin_core] fix segfault in fetch.files_static init
    + [mod_gnutls] support OCSP responses in sni backends

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Wed, 26 Jul 2017 17:14:01 +0000

lighttpd2 (2.0.0~snap-20151204-132651-g3a4698-1) unstable; urgency=low

  * new snapshot g3a4698
    + [pattern] fix all calls of li_pattern_eval to provide latest regex match

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Fri, 18 Dec 2015 07:09:03 +0000

lighttpd2 (2.0.0~snap-20150810-103940-gd2c6a2-2.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Make -bin require exact -lib version, make -dev and -dbg require -bin
    instead of main package

 -- Stefan Bühler <stbuehler@web.de>  Wed, 28 Oct 2015 21:55:34 +0100

lighttpd2 (2.0.0~snap-20150810-103940-gd2c6a2-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * add lost systemd unit

 -- Stefan Bühler <stbuehler@web.de>  Sat, 24 Oct 2015 14:05:43 +0200

lighttpd2 (2.0.0~snap-20150810-103940-gd2c6a2-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * fix package dependencies for hopefully more smooth upgrade paths

 -- Stefan Bühler <stbuehler@web.de>  Sat, 24 Oct 2015 13:58:59 +0200

lighttpd2 (2.0.0~snap-20150810-103940-gd2c6a2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Split lighttpd2-bin packages containing the binaries; lighttpd2 contains
    the systemd service now and conflicts with lighttpd2-run

 -- Stefan Bühler <stbuehler@web.de>  Sat, 24 Oct 2015 13:43:28 +0200

lighttpd2 (2.0.0~snap-20150810-103940-gd2c6a2-2) unstable; urgency=low

  * Package rebuild

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Fri, 23 Oct 2015 15:44:55 +0000

lighttpd2 (2.0.0~snap-20150810-103940-gd2c6a2-1) unstable; urgency=low

  * new snapshot gd2c6a2
    + [core] close out stream nicely on regular shutdown (fixes openssl session problem)
    + [mod_openssl] various fixes, fix error handling
    + Add systemd unit file
    + track event "names" for debugging
    + [mod_debug] debug events
    + [lua] handle filter->vr == NULL in lua filters, handle filter->in == NULL in xsendfile
    + mimetypes.conf: add some new mime types, remove .dat, .sha1, .md5, update .vcf
    + [mod_debug] show more details for events
    + [common] fix out-of-bounds read in li_sockaddr_to_string
    + [automake] add missing files to dist tar
    + [common] format IPv6 addresses with port as [addr]:port (added the square brackets)
    + [request parser] adapt whitespace removal from response parser, fixes bug removing last character if CR was missing
    + [streams] improve stream handling, hopefully fixes bug with lingering backend connections
    + [debug] provide more unique event names for waitqueues
    + ignore CMakeLists.txt.user (qtcreator)
    + [ssl] don't exit early when there is no data to write; otherwise EOS stream handling is not triggered
    + use g_assert instead of g_assert_true for older glib2 versions

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Thu, 13 Aug 2015 19:14:57 +0000

lighttpd2 (2.0.0~snap-20141109-104005-g93d04a-1.1) UNRELEASED; urgency=medium

  * Non-maintainer upload.
  * ignore missing doc/*.js sources

 -- Stefan Bühler <stbuehler@web.de>  Mon, 10 Aug 2015 12:34:48 +0200

lighttpd2 (2.0.0~snap-20141109-104005-g93d04a-1) unstable; urgency=low

  * new snapshot g93d04a
    + [doc] clarify "physical.exists" semantic
    + [mod_gnutls] when an alert is received print its actual value
    + [mod_gnutls] allow pemfile to accept a key-value list of a certificate and key
    + [doc] improve section about DH/DSA parameters in mod_gnutls
    + [doc] mod_gnutls: add comment that reusing keys in DH is not recommended anyway
    + [mod_gnutls] improve alert handling
    + [mod_openssl] allow all authentication methods in default cipher string
    + [tests] use gnutls certtool to create test ca


