=== debian/control ===
Source: lighttpd2
Section: web
Priority: extra
Maintainer: Stefan Bühler <source@stbuehler.de>
Uploaders:
 Lighttpd Buildbot <buildbot@lighttpd.net>,
 Jenkins (autobuilder) <jenkins@lighttpd.net>,
Build-Depends:
 debhelper (>= 9),
 autotools-dev,
 libev-dev,
 ragel,
 libglib2.0-dev,
 liblua5.1-dev,
 zlib1g-dev,
 libbz2-dev,
 pkg-config,
 libssl-dev,
 libgnutls28-dev,
 libidn11-dev,
 libunwind8-dev,
 python (>= 2.6),
 python-pycurl,
 fcgi-cgi,
 dh-systemd (>= 1.5),
Standards-Version: 3.9.8
Homepage: https://redmine.lighttpd.net/projects/lighttpd2/wiki

Package: lighttpd2
Architecture: any
Depends:
 lighttpd2-bin (>= ${source:Version}),
 systemd,
 adduser,
 ${misc:Depends},
Provides:
 httpd,
 httpd-cgi,
 httpd-wsgi,
Conflicts:
 lighttpd2-run
Description: lightweight  webserver (systemd service)
 lighttpd is a secure, fast, compliant, and very flexible web-server that
 has been optimized for high-performance environments. It has a very low
 memory footprint compared to other webservers and takes care of cpu-load.
 Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
 and many more) make lighttpd the perfect webserver-software for every
 server that suffers load problems.
 .
 This package provides the systemd service. If you don't have systemd you
 should install lighttpd2-run for a runit service.

Package: lighttpd2-run
Architecture: all
Depends:
 lighttpd2-bin (>= ${source:Version}),
 runit (>= 1.8.0-2),
 adduser,
 ${misc:Depends},
Provides:
 httpd,
 httpd-cgi,
 httpd-wsgi,
Conflicts:
 lighttpd2,
Description: lightweight webserver (runit service)
 lighttpd is a secure, fast, compliant, and very flexible web-server that
 has been optimized for high-performance environments. It has a very low
 memory footprint compared to other webservers and takes care of cpu-load.
 Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
 and many more) make lighttpd the perfect webserver-software for every
 server that suffers load problems.
 .
 This package provides a runit service. Activate it with:
 .
 ln -s /etc/sv/lighttpd2 /etc/service/

Package: lighttpd2-bin
Architecture: any
Depends: liblighttpd2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: lighttpd2 (<< 2.0.0~snap-20150810-103940-gd2c6a2-2.2)
Breaks: lighttpd2 (<< 2.0.0~snap-20150810-103940-gd2c6a2-2.2)
Suggests:
 spawn-fcgi,
 fcgi-cgi,
 lighttpd2 (= ${binary:Version}) | lighttpd2-run (= ${binary:Version}),
Provides:
 httpd,
 httpd-cgi,
 httpd-wsgi,
Description: lightweight webserver (binaries)
 lighttpd is a secure, fast, compliant, and very flexible web-server that
 has been optimized for high-performance environments. It has a very low
 memory footprint compared to other webservers and takes care of cpu-load.
 Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
 and many more) make lighttpd the perfect webserver-software for every
 server that suffers load problems.
 .
 This package includes the core binaries. To automatically run it you
 should install either lighttpd2 (systemd service) or lighttpd2-run (runit
 service)

Package: liblighttpd2
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: lightweight webserver - common libraries
 lighttpd is a secure, fast, compliant, and very flexible web-server that
 has been optimized for high-performance environments. It has a very low
 memory footprint compared to other webservers and takes care of cpu-load.
 Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
 and many more) make lighttpd the perfect webserver-software for every
 server that suffers load problems.

Package: lighttpd2-dev
Architecture: any
Depends:
 lighttpd2-bin (= ${binary:Version}),
 liblighttpd2 (= ${binary:Version}),
 ${misc:Depends}
Description: lightweight webserver - development files for modules
 lighttpd is a secure, fast, compliant, and very flexible web-server that
 has been optimized for high-performance environments. It has a very low
 memory footprint compared to other webservers and takes care of cpu-load.
 Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
 and many more) make lighttpd the perfect webserver-software for every
 server that suffers load problems.
