## lighttpd2 2.0.0%7esnap-20251224-153435-g42018b

=== debian/changelog ===
lighttpd2 (2.0.0~snap-20251224-153435-g42018b-1) unstable; urgency=low

  * new snapshot g42018b
    + [build] support lua 5.5 (no code changes needed)
    + [build] use more recent lua versions with ubuntu (5.4) and alpine (5.5)
    + [mod_openssl] use uint64_t (instead of long) for options
    + [connection] fix signed compare in PROXYv2 handling
    + [connection] fix format strings (integer width) in PROXYv2 debug
    + [tests] don't flush closed log files
    + [tests] fix finding sha1[sum] binary
    + [tests] drop old macos workarounds

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Wed, 24 Dec 2025 15:34:50 +0000

lighttpd2 (2.0.0~snap-20250725-190751-gace2c0-1) unstable; urgency=low

  * new snapshot gace2c0
    + [tests] curl SOCKOPT_ALREADY_CONNECTED broken vom 7.88 to 8.0

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Fri, 25 Jul 2025 19:08:02 +0000

lighttpd2 (2.0.0~snap-20250725-175751-gd400f4-1) unstable; urgency=low

  * new snapshot gd400f4
    + [tests] handle older (py)curl without HAPROXY_PROTOCOL support
    + [build] run apt-get update on github ubuntu workflow

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Fri, 25 Jul 2025 17:58:01 +0000

lighttpd2 (2.0.0~snap-20250725-174100-gda6c0d-1) unstable; urgency=low

  * new snapshot gda6c0d
    + [connection] move some connection finished handling to shared code
    + [tests] log a message to explain a lua error is expected afterwards
    + [connection] add comment about keepalive-reset in li_connection_reset
    + [connection] add PROXY parser (haproxy protocol)
    + [core/collect] fix use after free during shutdown

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Fri, 25 Jul 2025 17:42:18 +0000

lighttpd2 (2.0.0~snap-20250713-151256-ga14755-1) unstable; urgency=low

  * new snapshot ga14755
    + [lua] add more stack counting comments
    + [lua] fix stack cleanup in li_config_lua_load error handling
    + [stream] simple_socket_io: convert opaque context type to buffer
    + [connection] use proper struct for li_connection_simple_tcp state
    + [connection] split tcp/unix stream and plain http handling into separate files

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sun, 13 Jul 2025 15:13:08 +0000

lighttpd2 (2.0.0~snap-20250601-171253-gc6d66b-1) unstable; urgency=low

  * new snapshot gc6d66b
    + [tests] add test for map_cidr

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sun, 01 Jun 2025 17:13:02 +0000

lighttpd2 (2.0.0~snap-20250601-163259-gd0f7f1-1) unstable; urgency=low

  * new snapshot gd0f7f1
    + [plugin_core] add map_cidr action

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sun, 01 Jun 2025 16:33:09 +0000

lighttpd2 (2.0.0~snap-20250601-135251-g11df37-1) unstable; urgency=low

  * new snapshot g11df37
    + [mod_memcached] fix comment
    + [build]: add options for additional paths to search includes and libs in
    + [build] search bzip2 via pkg-config first
    + [log] fix _VR_* logging macros (NULL-pointer (offset) deref for vr == NULL)
    + [lua] fix broken _ENV in C (lua_getglobal) due to stack count error
    + [lua] add vr.error(...) (same as vr.print())
    + [lua] logging: run `tostring` with error handling
    + [tests] lua: make sure lua logging functions don't break request handling

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sun, 01 Jun 2025 13:53:00 +0000

lighttpd2 (2.0.0~snap-20250106-104251-g10303a-1) unstable; urgency=low

  * new snapshot g10303a
    + [build] fix ci-macos: pycurl, libev, keg-only packages
    + [core] fix potential use-after-free after li_job_reset

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Mon, 06 Jan 2025 10:43:02 +0000

lighttpd2 (2.0.0~snap-20250105-134250-g2306c2-3) unstable; urgency=medium

  * use pkgconf instead of pkg-config

 -- Stefan Bühler <source@stbuehler.de>  Sun, 05 Jan 2025 14:59:36 +0100

lighttpd2 (2.0.0~snap-20250105-134250-g2306c2-2) unstable; urgency=medium

  * use lua5.4 (instead of 5.1)

 -- Stefan Bühler <source@stbuehler.de>  Sun, 05 Jan 2025 14:50:50 +0100

lighttpd2 (2.0.0~snap-20250105-134250-g2306c2-1) unstable; urgency=low

  * new snapshot g2306c2
    + [build] accept and prefer lua 5.4, then 5.3, then 5.1

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sun, 05 Jan 2025 13:43:00 +0000

lighttpd2 (2.0.0~snap-20250105-132750-g9737e7-1) unstable; urgency=low

  * new snapshot g9737e7
    + [mod_lua] fix error handler stack position when calling lua "setups"
    + [tests] lua: make show_env_info function local
    + [lua] rename li_lua_push_lvalues_dict to li_lua_set_global_condition_lvalues
    + [lua] rework handling of environment (i.e. globals)
    + [lua] disable undocumented vr:subrequest(..)
    + [tests] append ".test"-suffix to vhost names, recreate test CA with wildcard and client certificate

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Sun, 05 Jan 2025 13:28:07 +0000

lighttpd2 (2.0.0~snap-20241227-223253-g60e2ad-1) unstable; urgency=low

  * new snapshot g60e2ad
    + [lua] use lua_{get,set}global instead of lua_{get,set}field with LUA_GLOBALSINDEX
    + [lua] use protected call to "tostring" in li_lua_print_get_string
    + [lua] get rid of LUA_GLOBALSINDEX in lua_settop_in_dicts
    + [mod_lua] LUA_GLOBALSINDEX should be the default environment of a new function, no need to set it
    + [lua] make remaining LUA_GLOBALSINDEX usages to manage global environment lua5.2+ compatible
    + [lua] provide li_lua_setfenv for lua5.2+
    + [lua] get rid of lua_getfenv when modifying env for request context _G for lua actions
    + [lua] replace lua5.1 luaL_register with wrapper for lua5.2 luaL_setfuncs
    + [lua] add li_lua_equal wrapper to use lua_compare on lua5.2 instead of lua_equal
    + [lua] use lua5.2+ lua_rawlen instead of lua_objlen
    + [lua] use luaL_checkinteger instead of luaL_checkint (deprecated in lua5.3)

 -- Jenkins (autobuilder) <jenkins@lighttpd.net>  Fri, 27 Dec 2024 22:33:02 +0000

lighttpd2 (2.0.0~snap-20241225-233250-g87290a-1) unstable; urgency=low


