=== debian/control ===
--- 
+++ 
@@ -1,35 +1,33 @@
 Source: lighttpd2
 Section: web
-Priority: extra
+Priority: optional
 Maintainer: Stefan Bühler <source@stbuehler.de>
 Uploaders:
  Lighttpd Buildbot <buildbot@lighttpd.net>,
  Jenkins (autobuilder) <jenkins@lighttpd.net>,
 Build-Depends:
- debhelper (>= 9),
- autotools-dev,
+ debhelper-compat (= 13),
+ meson,
  libev-dev,
  ragel,
  libglib2.0-dev,
- liblua5.1-dev,
+ liblua5.4-dev,
  zlib1g-dev,
  libbz2-dev,
- pkg-config,
+ pkgconf,
  libssl-dev,
  libgnutls28-dev,
- libidn11-dev,
+ libidn-dev | libidn11-dev,
  libunwind8-dev,
- python (>= 2.6),
- python-pycurl,
- fcgi-cgi,
- dh-systemd (>= 1.5),
-Standards-Version: 3.9.8
+ python3,
+ python3-pycurl,
+Standards-Version: 4.6.2
 Homepage: https://redmine.lighttpd.net/projects/lighttpd2/wiki
 
 Package: lighttpd2
 Architecture: any
 Depends:
- lighttpd2-bin (>= ${source:Version}),
+ lighttpd2-bin (>= ${binary:Version}),
  systemd,
  adduser,
  ${misc:Depends},
@@ -53,7 +51,7 @@
 Package: lighttpd2-run
 Architecture: all
 Depends:
- lighttpd2-bin (>= ${source:Version}),
+ lighttpd2-bin (>= ${binary:Version}),
  runit (>= 1.8.0-2),
  adduser,
  ${misc:Depends},
@@ -112,17 +110,3 @@
  Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
  and many more) make lighttpd the perfect webserver-software for every
  server that suffers load problems.
-
-Package: lighttpd2-dev
-Architecture: any
-Depends:
- lighttpd2-bin (= ${binary:Version}),
- liblighttpd2 (= ${binary:Version}),
- ${misc:Depends}
-Description: lightweight webserver - development files for modules
- lighttpd is a secure, fast, compliant, and very flexible web-server that
- has been optimized for high-performance environments. It has a very low
- memory footprint compared to other webservers and takes care of cpu-load.
- Its advanced feature-set (FastCGI, Auth, Output-Compression, URL-Rewriting
- and many more) make lighttpd the perfect webserver-software for every
- server that suffers load problems.
